.\" Time-stamp: <Sun Oct 31 12:43:03 EST 1999 ferguson>
.TH IPPD 1 "31 Oct 1999" "U of Rochester"
.SH NAME
ippd \- Internet Poker Protocol server
.SH SYNOPSIS
ippd
[\-port\ PORT]
[\-nodisplay]
[\-size\ large|small]
[\-cardsspeak]
[GAME\ [PARMS]]
.SH DESCRIPTION
.PP
This program launches the Internet Poker Protocol (IPP) server. See
the HTML documentation for details of the protocol. All message
traffic is logged to standard output.
.PP
The GAME parameter specifies what game to play. Possible values are:

.nf
.na
    HOLDEM \fIlow\fP \fIhigh\fP \fImaxraises\fP
    DRAW \fIlow\fP \fIhigh\fP \fImaxraises\fP
    STUD \fInumcards\fP \fIlow\fP \fIhigh\fP \fImaxraises\fP
.ad
.fi

where
.I low
and
.I high
are the low and high limits for the game, respectively, and
.I maxraises
is the number of raises allowed per betting round. For STUD games, the
.I numcards
parameter can be 5 or 7 (for five-card or seven-card stud, respectively).
By default,
the server will play a game of 10/20 Texas Hold 'Em with a maximum of
three raises per betting round.
.PP
The server waits for players to connect before the starting the game.
If running with a display, the ``Start'' button will start the game.
If running without a display, the server waits to read a Return from
its standard input before starting.
.SH OPTIONS
.PP
.IP "\fB-port\fP PORT"
Specifies an alternate TCP port on which to accept connections. The
default is port 9898.
.IP "\fB-nodisplay\fP"
Specifies that the server should run ``faceless.'' In this case, the
game must be started by typing a Return on the server's standard
input. The default is to use a graphical display.
.IP "\fB-size\fP large|small"
Specifies the size of the graphical display, if one is enabled. The
large display is more readable, but several small displays will fit on
a single workstation screen.
.IP "\fB-cardsspeak\fP"
If given, specifies that the server should simply compute the winner
of each hand rather than doing a showdown using IPP messages. The
default is to have the showdown.
.SH SEE ALSO
.PP
ipphuman(1),
ippplayer(1).
.SH BUGS
.PP
The determination of how much a player who has tapped out is ``in
for'' is not exactly as described in the rules. However, it's not too
bad, and the rest of the algorithm for resolving ties is implemented.
.PP
Timing out clients who don't respond is not yet implemented. Clients
who send too many consecutive unacceptable messages are disconnected
from the game.
.SH AUTHOR
.PP
George Ferguson (ferguson@cs.rochester.edu).


